#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import ctypes
import timeit

n = ( len( sys.argv ) > 1 and int( sys.argv[ 1 ] ) ) or 32

fib = ctypes.CDLL( './myfib.so' ).fib
fib.restype = ctypes.c_long
fib.argtypes = ( ctypes.c_ulong, )

print timeit.timeit( 'fib( %s )' % n, 'from __main__ import fib', number = 1 )

def pyfib( x ):
    if x < 2: return x
    return pyfib( x - 1 ) + pyfib( x - 2 )

print timeit.timeit( 'pyfib( %s )' % n, 'from __main__ import pyfib', number = 1 )
